import ts, { CompilerOptions, ScriptTarget } from "typescript";

/**
 * 编译typescript 代码为es5
 * @param code
 * @param options
 * @constructor
 */
export function CompilerCodeCompiler(code: string, options: CompilerOptions = {}) {
    const config: CompilerOptions = {
        ...options,
        target: ScriptTarget.ES5,
    }
    const { outputText: js } = ts.transpileModule(code, {
        compilerOptions: config as CompilerOptions
    });
    return js;
}