export async function installTSCompiler() {
    const typescriptServices = 'https://cdn.jsdelivr.net/npm/typescript@4.6.3/lib/typescriptServices.js'

    return installNpmPackage(typescriptServices)
        .then(() => {
            const ts = (window as any).ts;

            if (!ts) { return null }

            // console.log(`ts@${ts.version} installed in your console.`);

            return ts;
        });
}

export function insertScript(url: string): Promise<void> {
    return new Promise((resolve, reject) => {
        const script = document.createElement('script');
        script.src = url;
        script.onload = () => {
            resolve();
        };
        script.onerror = (error) => {
            reject(error);
        };
        document.head.appendChild(script);
    });
}

export function isURL(str: string): boolean {
    const pattern = new RegExp('^(https?|ftp)://[A-Za-z0-9-]+.[A-Za-z0-9]+[/=?%-&_~`@[]\'":+!]*([^<>"])*$');
    return pattern.test(str);
}

export function installNpmPackage(packageSrcOrName: string) {
    return insertScript(packageSrcOrName)
}
